#include "rcpp_hello_world.h"
#include "MathMatrix.h"
#include "MathVector.h"
#include "ExactLogisticRegression.h"

SEXP rcpp_hello_world(){
    using namespace Rcpp ;
    
    CharacterVector x = CharacterVector::create( "foo", "bar" )  ;
    NumericVector y   = NumericVector::create( 0.0, 1.0 ) ;
    List z            = List::create( x, y ) ;
    
    return z ;
}

RcppExport SEXP rcpp_exact_logistic(SEXP param_X, SEXP param_Y, SEXP param_nRound, SEXP param_col) {
    //using namespace Rcpp;
    Rcpp::NumericMatrix xx(param_X);
    Rcpp::NumericMatrix yy(param_Y);
    Rcpp::NumericVector nr(param_nRound);
    Rcpp::NumericVector col(param_col);

    // type conversion
    Matrix my_x(xx.nrow(), xx.ncol());
    // std::cout<< "nr = " << my_x.rows << " nc = "<< my_x.cols << std::endl;
    for (int i = 0 ; i < xx.nrow(); i++ )
        for (int j = 0; j < xx.ncol(); j++)
            my_x[i][j] = xx(i,j);
    Vector my_y(yy.size());
    for (int i = 0; i < yy.size() ; i++ )
        my_y[i] = yy[i];
    int my_nr = nr[0];
    int my_col= col[0];

    ExactLogisticRegression elr;
    Rcpp::List z;
    z["p"]=1.00;
    z["beta"] = 0.00 ;
    if (!elr.FitModel(my_x, my_y, my_nr, my_col)) {
        z["p"]=elr.GetExactPvalue();
        z["beta"] = elr.GetBetaEstimate() ;
    } else {
        std::cerr << "Fit does not succeed. " << std::endl;
    }
    return z;
}
